///////////////////////////////////
//															 //
//  CommonBase Class, Definition //
//															 //
//		Chungho Chau							 //
//															 //
///////////////////////////////////

#ifndef COMMONBASE_CLASS 
#define COMMONBASE_CLASS

#include "Generic.h"
#include "VString.h"


class CommonBase{
	public:
				CommonBase(const char *name, const char *address)
					: m_name(name), m_address(address) {}

				CommonBase() 
					: m_name("Default"), m_address("Default") {}
				
				virtual ~CommonBase() = 0 {}

				VString GetName() const	{ return m_name;}
				VString GetAddress() const { return m_address; }

				void SetName   (const VString &other) { m_name = other;}
				void SetAddress(const VString &other) { m_address = other;}
					

				void Display(BOOL needCRLF = FALSE);


	private:
				VString m_name;
				VString m_address;

				CommonBase(const CommonBase &other);
				CommonBase &operator= (const CommonBase &other);
				BOOL operator== (const CommonBase &other) const;
			


};



#endif