////////////////////////////////////
//															  //
//  Employee Class, Definition		//
//															  //
//		Chungho Chau							  //
//															  //
////////////////////////////////////

#ifndef EMPLOYEE_CLASS 
#define EMPLOYEE_CLASS

#include "CommonBase.h"


class Employee: public virtual CommonBase{

	public:
				Employee(const char *name, const char *address, double salary)
					: CommonBase(name, address), m_salary(salary) {}

				Employee(double salary)
					: m_salary(salary) {}

				virtual ~Employee() {}

				double GetSalary(void) const  {return m_salary;}
				void SetSalary(double salary) {m_salary = salary;}

				void Display(BOOL needCRLF = FALSE);

	private:
				double m_salary;

				Employee(const Employee &other);
				Employee &operator= (const Employee &other);
				BOOL operator== (const Employee &other) const;
};



#endif