////////////////////////////////////
//															  //
//  StockHolder Class, Definition //
//															  //
//		Chungho Chau							  //
//															  //
////////////////////////////////////

#ifndef STOCKHOLDER_CLASS 
#define STOCKHOLDER_CLASS

#include "CommonBase.h"

class StockHolder: public virtual CommonBase{
	public:
				StockHolder(const char *name, const char *address, int share)
					: CommonBase(name,address), m_share(share) {}

				StockHolder(int share): m_share(share) {} // require default ctor in CommonBase()

				StockHolder(const char *name, const char *address)
					: CommonBase(name,address) {}

				virtual ~StockHolder() {}

				int GetNumOfShare(void) const {return m_share;}
				void SetNumOfShare (int share) {m_share = share;}

				void Display(BOOL needCRLF = FALSE);

	private:
				int m_share;

				StockHolder(const StockHolder &other);
				StockHolder &operator= (const StockHolder &other);
				BOOL operator== (const StockHolder &other) const;
};


#endif