// VString Header File
// File VString.h

#ifndef VSTRING_CLASS  // a must for inheritance
#define VSTRING_CLASS

#include "Generic.h"
#include <iostream.h>

class VString 
{
	//Overloading ostream
	friend ostream & operator<< (ostream &output, const VString &other);
	friend VString operator+ (char *string, const VString &other);

	public:
				
				VString (const char *InputString);
				~VString ();				
				VString(const VString &other);

				//Overloading operator+
				VString operator+ (const VString &other) const;
				VString operator+ (const char *other) const; 

				// Member Functions
				void Display (BOOL needCRLF = FALSE) const;
				void Display (const char *prefix, const char *suffix, BOOL needCRLF) const;
				BOOL Put_At (const char Character, const int Index);
				char Get_At (const int Index) const;

				VString &operator= (const VString &other);
				VString &operator= (const char *other); 
	
				BOOL operator== (const VString &other) const;
				BOOL operator== (const char *other) const;

				VString &operator+= (const VString &other);
				VString &operator+= (const char *other);

				VString &Append (const VString &other);
				VString &Append (const char *other);

				void Display_Substring (const int Start, const int End) const;
				BOOL Is_Empty(void) const;
				BOOL Length(void) const;
	
	private:
				
				int   m_length;		// length of the string
				char *m_string;		// character pointer to a flexible string data array
};

#endif